# boja zadata u rgb kolor modelu
r=125
g=3
b=125 

### konverzija boje u HSV kolor model ###

#transformacija zadatih vrednosti kanala u  opseg [0,1]
rp = r/255
gp = g/255 
bp = b/255 

Cmax = max(rp, gp, bp)
Cmin = min(rp, gp, bp)

delta = Cmax - Cmin 

#racnuanje vrednosti za nijansu
if delta == 0 :
    h=0
elif Cmax == rp:
    h=60 * ( (gp - bp)/delta % 6 )   # ostakat: n % 6
elif Cmax == gp:
    h=60 * ((bp - rp)/delta +2)
else:
    h=60*((rp - gp)/delta + 4)


#racnuanje vrednosti za zasicenost
if Cmax==0:
    s=0 
else:
    s=delta/Cmax 

#racnuanje vrednosti za sjajnost
v=Cmax 

#ispis boje u HSV kolor modelu
print(f'HSV: h:{h:.0f} s:{(s*100):.2f}% v:{(v*100):.2f}%')

####komentari o formatiranju ispisa ####
# f' {promenljiva}'  - ispis niske koriscenjem vrednosti promenljive 
# '{0} {1}'.format(prom1, prom2) = f'{prom1} {prom2}'
# moze se zadati i format o 
# {prom : informacije o formatiranju}
#                       l.m f   - zapis realnog broja sa l mesta i m cifara iza tacke
#                       napomena: ako je potrebno, u py pri ispisu ce biti prosiren broj l
#                                 da bi se validno zapisao broj
#                       ili samo 
#                        .mf gde je 
#                        .m broj cifara iza tacke (za ceo deo se pri ispisu uzima koliko je potrebno 
#                                                  mesta za validan zapis cifara i tacke)    
#                         f - float (tip ispisa)

#
# tipovi: f  - float - realan broj
#         d  - ceo broj
#         s  - niska, string
#         b  - binarni broja
#         x  - heksadekadni 

#zapis boje heksadekadno
hex_broj = f'#{r:02x}{g:02x}{b:02x}'

#objasnjenje o formatiranju 
# {r:02x} ili uopsteno  {prom:02x}
# u 02x
# x oznacava ispis broja prom heksadekadno (tip) 
# 2 oznacava ispis sa 2 cifre
# 0 oznacava ispis sa vodecim 0 ako se vrsi dopuna do zaljene duzine ispisa (u nasem slucaju do 2)  

#mozete probati sledece primere ispisa uklanjanjem oznake za komentar # 
x=5
#print('ispis x=5 kao')
#print(f'ceo broj: {x:d}')
#print(f'ceo broj na 3 mesta sa vodecim 0: {x:3d}')
#print(f'realan broj: {x:F}')
#print(f'realan broj sa 1 decimalom: {x:.1f}')
#print(f'binarni broj: {x:b}')
#print(f'binarni broj sa 16 cifara i vodecim 0: {x:016b}')
#print(f'heksadekadni broj: {x:x}')
#print(f'heksadekadni broj sa 4 mesta: {x:4x}')
#print(f'heksadekadni broj sa 4 mesta i vodecim 0: {x:04x}')

#ispis heksadekadnog zapisa broja 
print(hex_broj)

### konverzija boje u HLS kolor model ###
# h je vec izracunato u okviru konverzije boje u HSV kolor model

l = (Cmax + Cmin) / 2

if delta == 0:
    s = 0
else:
    s= delta / (1 - abs(2*l - 1))

print(f'HLS: h:{h:.0f} s:{(s*100):.3f}% l:{(l*100):.3f}% ')

### konverzija boje u CMYK kolor model ###
k = 1 - max(rp, gp, bp)
c = (1-rp-k)/(1-k)
m = (1-gp-k)/(1-k)
y = (1-bp-k)/(1-k)

print( f'CMYK: c:{(c*100):.2f}% m:{(m*100):.2f}% y:{(y*100):.2f}% k:{(k*100):.2f}%')
